;http session's authentication laye
(define-module (alterator http auth)
  :use-modules (alterator http session)
  :use-modules (alterator lookout popup)
  :use-modules (alterator lookout document)
  :export (auth-http-request))

;demo authorizarion
(define (auth-user user passwd)
  (format #t "authentication for user=~A, passwd=~A~%" user passwd)
  (and (string=? user "root")
       (string=? passwd "root")))

(define (auth-permission-denied)
  `(auth-answer content ((command action "forbidden"))))

(define (auth-permission-granted next content . args)
  (and content `(auth-answer ,@args content ,(next content))))

(define (create-and-start)
  (define-operation start-thread)
  (let ((dlg (init-popup (document:subdocument '/))))
    (start-thread dlg)
    dlg))

;auth processing here
(define (auth-http-request cmd next)
  (format #t "auth=~A~%>>>sessions=~S~%" cmd  http-session-list)

  (let ((content (cond-cdr (command-arg-ref cmd 'content)))
	(user	 (cond-cdr (command-arg-ref cmd 'user)))
	(password (cond-cdr (command-arg-ref cmd 'password)))
	(lang (cond-cdr (command-arg-ref cmd 'language)))
	(session-id (cond-cdr (command-arg-ref cmd 'session-id))))

    (cond
      (session-id
       (let ((session (find-http-session user session-id)))
         (if session
              (with-fluids ((http-session session)) (auth-permission-granted next context))
              (auth-permission-denied))))

      ((and user password (auth-user user password))
       (with-fluids ((http-session (make-http-session user
                                                     lang
                                                     (create-and-start))))
                    (auth-permission-granted next content
                                             'user user
                                             'session-id (http-session-id))))

      (else (auth-permission-denied)))))


i